#ifndef NETLINK_BRIDGE_VLAN_H_
#define NETLINK_BRIDGE_VLAN_H_

#ifdef __cplusplus
extern "C" {
#endif

struct rtnl_bridge_vlan;

/* General */
extern struct rtnl_bridge_vlan *rtnl_bridge_vlan_alloc(void);
extern void rtnl_bridge_vlan_put(struct rtnl_bridge_vlan *);

extern int rtnl_bridge_vlan_alloc_cache_flags(struct nl_sock *,
					      struct nl_cache **,
					      unsigned int);
extern int rtnl_bridge_vlan_alloc_cache(struct nl_sock *, struct nl_cache **);

extern int rtnl_bridge_vlan_build_add_request(struct rtnl_bridge_vlan *, int,
					      struct nl_msg **);
extern int rtnl_bridge_vlan_add(struct nl_sock *, struct rtnl_bridge_vlan *,
				int);
extern int rtnl_bridge_vlan_build_change_request(struct rtnl_bridge_vlan *,
						 struct rtnl_bridge_vlan *,
						 int, struct nl_msg **);
extern int rtnl_bridge_vlan_change(struct nl_sock *, struct rtnl_bridge_vlan *,
				   struct rtnl_bridge_vlan *, int);
extern int rtnl_bridge_vlan_build_delete_request(
	const struct rtnl_bridge_vlan *, struct nl_msg **);
extern int rtnl_bridge_vlan_delete(struct nl_sock *,
				   const struct rtnl_bridge_vlan *);

/* attribute modification */
extern void rtnl_bridge_vlan_set_ifindex(struct rtnl_bridge_vlan *, int);
extern int rtnl_bridge_vlan_get_ifindex(struct rtnl_bridge_vlan *);
extern void rtnl_bridge_vlan_set_vid(struct rtnl_bridge_vlan *, uint16_t);
extern uint16_t rtnl_bridge_vlan_get_vid(struct rtnl_bridge_vlan *);
extern void rtnl_bridge_vlan_set_flags(struct rtnl_bridge_vlan *, uint16_t);
extern uint16_t rtnl_bridge_vlan_get_flags(struct rtnl_bridge_vlan *);
extern void rtnl_bridge_vlan_set_state(struct rtnl_bridge_vlan *, uint8_t);
extern uint8_t rtnl_bridge_vlan_get_state(struct rtnl_bridge_vlan *);
extern void rtnl_bridge_vlan_set_tunid(struct rtnl_bridge_vlan *, uint32_t);
extern uint32_t rtnl_bridge_vlan_get_tunid(struct rtnl_bridge_vlan *);

extern int rtnl_link_bridge_vlan_get_port_state(struct rtnl_link *, uint16_t);

extern const char *rtnl_bridge_vlan_port_states[];

#ifdef __cplusplus
}
#endif

#endif
