/*
 *	This library is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU Lesser General Public
 *	License as published by the Free Software Foundation version 2.1
 *	of the License.
 *
 * Copyright (c) 2021 Cumulus Networks <dev-support@cumulusnetworks.com>
 */

#ifndef NETLINK_LWT_IP_H_
#define NETLINK_LWT_IP_H_

#include <netlink/route/lwt.h>

#ifdef __cplusplus
extern "C" {
#endif

struct rtnl_lwt_ip_encap {
	uint64_t li_id;
	struct nl_addr *li_dst;
};

#ifdef __cplusplus
}
#endif

int rtnl_lwt_is_ip(struct rtnl_lwt_encap *encap);
struct rtnl_lwt_ip_encap *rtnl_lwt_ip_encap_hdr(struct rtnl_lwt_encap *encap);

#endif /* NETLINK_LWT_IP_H_ */
